library ieee;
use ieee.std_logic_1164.all;
use work.P_DISPLAY.all;

entity CAMERA is
  port(CLK         : in     std_ulogic;
       RESET       : in     std_ulogic;
       TRIGGER     : in     std_ulogic;
       SWITCH      : in     std_ulogic;
       KEYPAD      : in     std_ulogic_vector(9 downto 0);
       MOTOR_READY : in     std_ulogic;
       EXPOSE      : buffer std_ulogic;
       DISPLAY     : out    T_DISPLAY);
end CAMERA;


architecture STRUCT of CAMERA is
  -- Camera components:
  -- DISP_DRV
  -- DECODER
  -- EXP_FF
  -- DISP_CTRL
  -- MOTOR_TIMER
  -- EXP_CTRL
  -- MAIN_CTRL

  -- All signals that are not present on the camera entity must be
  -- declared as internal signals
    
begin
  -- Instantiation of the components
  U_DECODER : DECODER
    port map(
      KEYPAD      => KEYPAD,
      KEY         => W_KEY);
end STRUCT;


configuration CFG_CAMERA of CAMERA is
  for STRUCT
    -- The case-based architecture shall be selected for the DECODER
  end for;
end CFG_CAMERA;
