library ieee;
use ieee.std_logic_1164.all;
use work.P_DISPLAY.all;


entity DISP_DRV is
  port(ERROR      : in  std_ulogic;
       SHOW_TIME  : in  std_ulogic;
       NO_PICS    : in  T_DIGITS;
       EXP_TIME   : in  T_DIGITS;
       DISPLAY    : out T_DISPLAY);
end DISP_DRV;

architecture RTL of DISP_DRV is
  signal DISP_PHOTO : T_DIGITS;
begin
  DISP_MUX:process (SHOW_TIME, ERROR,
                    EXP_TIME, NO_PICS)
  begin
    if ERROR = '1' then
      DISP_PHOTO <= (10, 10, 10);
    elsif SHOW_TIME = '0' then 
      DISP_PHOTO <= NO_PICS;
    else
      DISP_PHOTO <= EXP_TIME;
    end if;
  end process DISP_MUX;

  DECODE: process (DISP_PHOTO)
  begin
    for I in T_DISPLAY'range loop
      case DISP_PHOTO(I) is
        when 0      => DISPLAY(I) <= SEG_0;
        when 1      => DISPLAY(I) <= SEG_1;
        when 2      => DISPLAY(I) <= SEG_2;
        when 3      => DISPLAY(I) <= SEG_3;
        when 4      => DISPLAY(I) <= SEG_4;
        when 5      => DISPLAY(I) <= SEG_5;
        when 6      => DISPLAY(I) <= SEG_6;
        when 7      => DISPLAY(I) <= SEG_7;
        when 8      => DISPLAY(I) <= SEG_8;
        when 9      => DISPLAY(I) <= SEG_9;
        when others => DISPLAY(I) <= SEG_E;
      end case;
    end loop;
  end process DECODE; 
end RTL;
